# 关于 exercise.rs
> 英文版 [传送门](https://exercise.rs)

欢迎大家来到 `exercise.rs`，在来到这里之前不知道你有没有碰到过以下问题:

- 学完知识，想要针对性的练习，但是只能找到一些不痛不痒的习题
- 一些 Rust 工具、标准库等相关的习题更是一个都找不到
- 做完了习题还是一片茫然，不知道下一步该做什么，上手写项目吧，发现几乎无处下手

如果你曾经和我有一样的问题，那来到这里就对了：**在这里你能找到大量从简单到困难的 Rust 练习题，不仅能针对性巩固你所学过的知识，解决 Rust 语言难以上手应用的问题**。

## 在线阅读
本书同时提供了中文和英文版本:
- English: [https://exercise.rs](https://exercise.rs)
- 简体中文: [https://zh.exercise.rs](https://zh.exercise.rs)

## 关于练习题的说明
- 我们的练习只有一个目的：那就是让编译通过，但是你需要注意相应的提示，例如删除所有代码也可以让练习通过
- 难度等级: 简单: 🌟  中等: 🌟🌟  困难: 🌟🌟🌟  地狱: 🌟🌟🌟🌟
- 一切都在线化： 阅读、编辑和测试代码，当然还包括错误提示

## 欢迎你，贡献者
本项目欢迎一切贡献者，特别是怀揣题库的兄弟，你所贡献的每一道题都会注明你的昵称和个人链接，是时候让全世界看看咱的风采了。

## 学习 Rust 语言
我们强烈推荐在开始做练习之前，先看看 [<<Rust语言圣经>>]((https://course.rs)) 这本书，它覆盖了从入门到精通所需的全部知识，相信我，里面绝对有你所需要的 Rust 知识。

(悄咪咪的告诉咱中国用户， `exercise.rs` 章节目录和 <<Rust语言圣经>> 完全相同，大家猜猜为什么)




## 对比 rustlings
[Rustlings](https://github.com/rust-lang/rustlings) 只包含了一些小型的、简单的练习题，说实话并不能帮你熟悉学到的 Rust 知识，更别提帮你打通从学习到实践的道路了。

另一个问题就是 rustlings 需要先下载到本地，然后编译运行，无法在线使用。

## 对比 Rust By Example
[Rust By Example](https://doc.rust-lang.org/stable/rust-by-example/) 是相当不错的在线练习题，相比之前，`exercise.rs` 拥有以下优势 :

- 内容覆盖面更广，且练习题更多、针对性更强，充分满足大家做题的快乐
- 难度从简单到困难都有，且更贴合实际
- 跟随 Rust 版本实时更新,
- `course.rs` 和 `exercise.rs` 看域名就知道，它非常有信心才敢使用这两个针对性如此之强的域名，而信心来源于**高质量**



